import { Observable } from 'rxjs';
import { ToastMessage, ToastMessageParams } from './Models/toast-message.models';
export declare class AngularBootstrapToastsService {
    private toastsList;
    readonly ToastsList$: Observable<ToastMessage[]>;
    private defaultTitle;
    readonly DefaultTitle: string;
    private defaultText;
    readonly DefaultText: string;
    private defaultDuration;
    readonly DefaultDuration: number;
    private minDuration;
    private maxMessageId;
    constructor();
    /** Show success toast message */
    showSimpleToast(params: ToastMessageParams): ToastMessage;
    /** Show toast message with confirmation and decline button variants */
    showConfirmToast(params: ToastMessageParams): ToastMessage;
    /** Change Default **Title** for all toasts wich not get `title` property from params when creating */
    changeDefaultTitle(newTitle: string): void;
    /** Change Default **Text** for all toasts wich not get `text` property from params when creating */
    changeDefaultText(newText: string): void;
    /** Change Default **Duration** for all toasts */
    changeDefaultDuration(duration: number): void;
    private createToast;
    private validateParams;
    private validateTitle;
    private validateText;
    private validateDuration;
}
